org.apache.hc.core5.http.io.entity

## Class StringEntity

- java.lang.Object
- - org.apache.hc.core5.http.io.entity.AbstractHttpEntity
  - - org.apache.hc.core5.http.io.entity.StringEntity

- All Implemented Interfaces:
    Closeable, AutoCloseable, EntityDetails, HttpEntity

      @Contract(threading=IMMUTABLE)
      public class StringEntity
      extends AbstractHttpEntity

  A self contained, repeatable entity that obtains its content from a `String`.
  Since:
    4.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `StringEntity(String string)` Creates a StringEntity with the specified content.
    `StringEntity(String string, Charset charset)` Creates a StringEntity with the specified content and charset.
    `StringEntity(String string, Charset charset, boolean chunked)`
    `StringEntity(String string, ContentType contentType)`
    `StringEntity(String string, ContentType contentType, boolean chunked)`
    `StringEntity(String string, ContentType contentType, String contentEncoding, boolean chunked)` Creates a StringEntity with the specified content and content type.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()`
    `InputStream` | `getContent()` Returns a content stream of the entity.
    `long` | `getContentLength()` Returns length of the entity, if known.
    `boolean` | `isRepeatable()` Tells if the entity is capable of producing its data more than once.
    `boolean` | `isStreaming()` Tells whether this entity depends on an underlying stream.
    `void` | `writeTo(OutputStream outStream)` Writes the entity content out to the output stream.

    - ### Methods inherited from class org.apache.hc.core5.http.io.entity.AbstractHttpEntity

      `getContentEncoding, getContentType, getTrailerNames, getTrailers, isChunked, toString, writeTo`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### StringEntity

          public StringEntity(String string,
                              ContentType contentType,
                              String contentEncoding,
                              boolean chunked)

      Creates a StringEntity with the specified content and content type.
      Parameters:
        `string` - content to be used. Not `null`.
        `contentType` - content type to be used. May be `null`, in which case the default MIME type `ContentType.TEXT_PLAIN` is assumed.
      Since:
        5.0

    - #### StringEntity

          public StringEntity(String string,
                              ContentType contentType,
                              boolean chunked)

    - #### StringEntity

          public StringEntity(String string,
                              ContentType contentType)

    - #### StringEntity

          public StringEntity(String string,
                              Charset charset)

      Creates a StringEntity with the specified content and charset. The MIME type defaults to "text/plain".
      Parameters:
        `string` - content to be used. Not `null`.
        `charset` - character set to be used. May be `null`, in which case the default is `StandardCharsets.ISO_8859_1` is assumed
      Since:
        4.2

    - #### StringEntity

          public StringEntity(String string,
                              Charset charset,
                              boolean chunked)

    - #### StringEntity

          public StringEntity(String string)

      Creates a StringEntity with the specified content. The content type defaults to `ContentType.TEXT_PLAIN`.
      Parameters:
        `string` - content to be used. Not `null`.
      Throws:
        `IllegalArgumentException` - if the string parameter is null

  - ### Method Detail

    - #### isRepeatable

          public final boolean isRepeatable()

      Description copied from interface: `HttpEntity`
      Tells if the entity is capable of producing its data more than once. A repeatable entity's getContent() and writeTo(OutputStream) methods can be called more than once whereas a non-repeatable entity's can not.
      Specified by:
        `isRepeatable` in interface `HttpEntity`
      Overrides:
        `isRepeatable` in class `AbstractHttpEntity`
      Returns:
        true if the entity is repeatable, false otherwise.

    - #### getContentLength

          public final long getContentLength()

      Description copied from interface: `EntityDetails`
      Returns length of the entity, if known.

    - #### getContent

          public final InputStream getContent()
                                       throws IOException

      Description copied from interface: `HttpEntity`
      Returns a content stream of the entity. `Repeatable` entities are expected to create a new instance of `InputStream` for each invocation of this method and therefore can be consumed multiple times. Entities that are not `repeatable` are expected to return the same `InputStream` instance and therefore may not be consumed more than once.

      If this entity belongs to an incoming HTTP message, calling `InputStream.close()` on the returned `InputStream` will try to consume the complete entity content to keep the connection alive. In cases where this is undesired, e.g. when only a small part of the content is relevant and consuming the complete entity content would be too inefficient, only the HTTP message from which this entity was obtained should be closed (if supported).

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated after the `InputStream.close()` method is invoked.

      Returns:
        content stream of the entity.
      Throws:
        `IOException` - if the stream could not be created
      See Also:
        `HttpEntity.isRepeatable()`

    - #### writeTo

          public final void writeTo(OutputStream outStream)
                             throws IOException

      Description copied from interface: `HttpEntity`
      Writes the entity content out to the output stream.

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated when this method returns.

      Specified by:
        `writeTo` in interface `HttpEntity`
      Overrides:
        `writeTo` in class `AbstractHttpEntity`
      Parameters:
        `outStream` - the output stream to write entity content to
      Throws:
        `IOException` - if an I/O error occurs

    - #### isStreaming

          public final boolean isStreaming()

      Description copied from interface: `HttpEntity`
      Tells whether this entity depends on an underlying stream. Streamed entities that read data directly from the socket should return `true`. Self-contained entities should return `false`. Wrapping entities should delegate this call to the wrapped entity.
      Returns:
        `true` if the entity content is streamed, `false` otherwise

    - #### close

          public final void close()
                           throws IOException

      Throws:
        `IOException`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.